#ifndef PANGULU_COMMON_H
#define PANGULU_COMMON_H
#ifdef __cplusplus
extern "C"
{
#endif
    #define CUDA_TSTRF
    #define CUDA_GESSM
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
    /*An impoortant structure is structure pangulu_Smatrix
    {
        calculate_type *value;
        calculate_type *value_CSC;
        int *CSR_to_CSC_index;
        int *CSC_to_CSR_index;
        int *rowpointer;
        int *columnindex;
        int *columnpointer;
        int *rowindex;
        int column;
        int row;
        int *bin_rowpointer;
        int *bin_rowindex;
        int *nnzU;
        calculate_type *CUDA_value;
        calculate_type *CUDA_value_CSC;
        int *CUDA_bin_rowpointer;
        int *CUDA_bin_rowindex;
        int *CUDA_CSR_to_CSC_index;
        int *CUDA_CSC_to_CSR_index;
        int *CUDA_rowpointer;
        int *CUDA_columnindex;
        int *CUDA_columnpointer;
        int *CUDA_rowindex;
        int *CUDA_nnzU;
    } pangulu_Smatrix;
It's parameters are explained as follows: 
value is the value stored in CSR format;
value_CSC is the value stored in CSC format;
CSR_to_CSC_index is CSR converted to CSC storage index;
CSC_to_CSR_index is CSC converted to CSR storage index;
rowpointer is the rowpointer stored in CSR format;
columnindex is the columnindex stored in CSR format;
columnrowpointer is the columnpointer stored in CSC format;
rowindex is the rowindex stored in CSC format;
row is this matrix row;
column is this matrix column;
bin_rowpointer is The matrix csr is adjusted and decomposed into different intervals 
according to the number of non-zero elements in each row. According to 1-32, 33-64, 
65-128, 129-256, 257-512, 513-1024, 1025-2048, 2049-4096, 4097-infinity.
the distribution is performed 
bin_rowindex Save the row index of bin_rowpointer. 
nnzU saves the number of non-zero elements in each row of the matrix .
CUDA_value is the value stored in CSR format and stored in CUDA_memory;
CUDA_value_CSC is the value stored in CSC format and stored in CUDA_memory;
CUDA_bin_rowpointer is bin_rowpointer stored in CUDA_memory;
CUDA_bin_rowindex is bin_rowindex stored in CUDA_memory;
CUDA_rowpointer is the rowpointer stored in CSR format and stored in CUDA_memory;
CUDA_columnindex is the columnindex stored in CSR format and stored in CUDA_memory;
CUDA_columnrowpointer is the columnpointer stored in CSC format and stored in CUDA_memory;
CUDA_rowindex is the rowindex stored in CSC formatand stored in CUDA_memory;
CUDA_nnzU is the nnzU stored in CUDA_memory;
An impoortant structure is structure pangulu_vector
    {
        calculate_type *value;
        int row;
    } pangulu_vector;
It's parameters are explained as follows: 
value is the value stored in dense vector;
row is the vector stored the vector's latitude;

An impoortant structure is structure pangulu_common
    {
        int P;
        int Q;
        int rank;
        int N;
        int NB;
        int size;
        char *file_name;
        struct timeval start_time;
        struct timeval stop_time;
    } pangulu_common;
It's parameters are explained as follows: 
P is number of row nodes;
Q is number of col nodes;
rank is process ID of the current node;
N is the matrix size;
NB is the matrix block size;
file_name is the rank 0 read the matrix name;
start_time is the test begin time;
stop_time is the test end time;

*/
#define calculate_type double
#define ERROR 0.000001
#define CHECK_ERROR 0.0001
#define BIN_LENGTH 12
#define pangulu_exchange_PQ(row, P) \
    (row + P - 1) % P;
#define pangulu_Calculate_Block(nrow, block) \
    nrow / block + ((nrow % block) ? 1 : 0)

    typedef struct pangulu_Smatrix
    {
        calculate_type *value;
        calculate_type *value_CSC;
        int *CSR_to_CSC_index;
        int *CSC_to_CSR_index;
        int *rowpointer;
        int *columnindex;
        int *columnpointer;
        int *rowindex;
        int column;
        int row;
        calculate_type *CUDA_value;
        calculate_type *CUDA_value_CSC;
        int *bin_rowpointer;
        int *bin_rowindex;
        int *CUDA_bin_rowpointer;
        int *CUDA_bin_rowindex;
        int *CUDA_CSR_to_CSC_index;
        int *CUDA_CSC_to_CSR_index;
        int *CUDA_rowpointer;
        int *CUDA_columnindex;
        int *CUDA_columnpointer;
        int *CUDA_rowindex;
        int *CUDA_nnzU;
        int *nnzU;
    } pangulu_Smatrix;

    typedef struct pangulu_vector
    {
        calculate_type *value;
        int row;
    } pangulu_vector;

    typedef struct pangulu_common
    {
        int P;
        int Q;
        int rank;
        int N;
        int NB;
        int size;
        char *file_name;
        struct timeval start_time;
        struct timeval stop_time;
    } pangulu_common;

#ifdef __cplusplus
}
#endif

#endif