#ifndef PANGULU_GESSM_FP64_CUDA_H
#define PANGULU_GESSM_FP64_CUDA_H
#ifdef __cplusplus
extern "C"
{
#endif
#include "pangulu_common.h"
#include "pangulu_cuda_interface.h"
    /*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
    void pangulu_gessm_fp64_cuda(pangulu_Smatrix *A,
                                 pangulu_Smatrix *L,
                                 pangulu_Smatrix *X)
    {

        pangulu_cuda_transport_CSR_to_CSC(A);
        pangulu_cuda_transport_CSR_to_CSC(L);

        int n = A->row;
        int nnzL = L->rowpointer[n];
        pangulu_gessm_cuda_kernel(n,
                                  nnzL, L->CUDA_columnpointer,
                                  L->CUDA_rowindex,
                                  L->CUDA_value_CSC,
                                  X->CUDA_columnpointer,
                                  X->CUDA_rowindex,
                                  X->CUDA_value_CSC,
                                  A->CUDA_columnpointer,
                                  A->CUDA_rowindex,
                                  A->CUDA_value_CSC);

        pangulu_cuda_transport_CSC_to_CSR(X);
        pangulu_cuda_memcpy_value_device_to_host(X);
    }

#ifdef __cplusplus
}
#endif

#endif