#ifndef PANGULU_TSTRF_FP64_CUDA_H
#define PANGULU_TSTRF_FP64_CUDA_H
#ifdef __cplusplus
extern "C"
{
#endif
#include "pangulu_common.h"
#include "pangulu_cuda.h"
    /*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
    void pangulu_tstrf_fp64_cuda(pangulu_Smatrix *A,
                                 pangulu_Smatrix *X,
                                 pangulu_Smatrix *U)
    {
        int n = A->row;
        int nnzU = U->rowpointer[n];
        pangulu_tstrf_cuda_kernel(n,
                                  nnzU,
                                  U->CUDA_rowpointer,
                                  U->CUDA_columnindex,
                                  U->CUDA_value,
                                  X->CUDA_rowpointer,
                                  X->CUDA_columnindex,
                                  X->CUDA_value,
                                  A->CUDA_rowpointer,
                                  A->CUDA_columnindex,
                                  A->CUDA_value);
        pangulu_cuda_memcpy_value_device_to_host(X);
    }
#ifdef __cplusplus
}
#endif

#endif